#include "test.h"

uint32_t test_add_compile(Value *memory) {
  uint32_t i = 0;
  memory[i++].u = OP(OP_LOADU, 0, 0, 0);
  memory[i++].u = 1;
  memory[i++].u = OP(OP_LOADU, 1, 0, 0);
  memory[i++].u = 2;
  memory[i++].u = OP(OP_ADD_UINT, 2, 1, 0); /* let sum = 1 + 2; */
  memory[i++].u = OP(OP_UINT_TO_STRING, 3, 2, 0);
  memory[i++].u = OP(OP_PRINT_STRING, 0, 3, 0); /* print(sum.toS()); */
  memory[i++].u = OP(OP_HALT, 0, 0, 0); /* explicit halt */
  return i;
}

uint32_t test_loop_compile(Value *memory) {
  uint32_t i = 0;
  memory[i++].u = OP(OP_LOADF, 0, 0, 0); /* let a = 5.0 */
  memory[i++].f = 5.0f;
  memory[i++].u = OP(OP_LOADI, 1, 0, 0); /* do (i = 5, 0, -1) { */
  memory[i++].i = 5;
  memory[i++].u = OP(OP_LOADI, 2, 0, 0); /* loop check value */
  memory[i++].i = 0;
  memory[i++].u = OP(OP_LOADI, 3, 0, 0); /* loop incriment value */
  memory[i++].i = -1;
  memory[i++].u = OP(OP_LOADU, 4, 0, 0); /* loop start */
  uint32_t jmp = i + 1;
  memory[i++].u = jmp;
  memory[i++].u = OP(OP_LOADF, 5, 0, 0);
  memory[i++].f = 5.0f;
  memory[i++].u = OP(OP_ADD_REAL, 0, 0, 5); /* a += 5.0; */
  memory[i++].u = OP(OP_ADD_INT, 1, 1, 3);  /* (implied by loop) i = i + (-1) */
  memory[i++].u = OP(OP_JGE_INT, 4, 1, 2);  /* } */
  memory[i++].u = OP(OP_REAL_TO_UINT, 1, 0, 0); /* let b = a as nat; */
  memory[i++].u = OP(OP_READ_STRING, 2, 0, 0);  /* let user_string = gets(); */
  memory[i++].u = OP(OP_UINT_TO_STRING, 3, 1, 0);
  memory[i++].u = OP(OP_PRINT_STRING, 0, 3, 0); /* print(a.toS()); */
  memory[i++].u = OP(OP_REAL_TO_STRING, 3, 0, 0);
  memory[i++].u = OP(OP_PRINT_STRING, 0, 3, 0); /* print(b.toS()); */
  memory[i++].u = OP(OP_PRINT_STRING, 0, 2, 0); /* print(user_string); */
  memory[i++].u = OP(OP_HALT, 0, 0, 0);         /* program done */
  return i;
}

uint32_t test_add_function_compile(Value *memory) {
  uint32_t i = 0;
  /* fn main() */
  memory[i++].u = OP(OP_LOADI, 0, 0, 0); /* 1 */
  memory[i++].i = 1;
  memory[i++].u = OP(OP_PUSHI, 0, 0, 0);
  memory[i++].u = OP(OP_LOADI, 0, 0, 0); /* 1 */
  memory[i++].i = 1;
  memory[i++].u = OP(OP_PUSHI, 0, 0, 0);
  memory[i++].u = OP(OP_CALL, 0, 0, 0); /* ); */
  memory[i++].u = 12;
  memory[i++].u = OP(OP_POPI, 0, 0, 0); /* get return value */
  memory[i++].u = OP(OP_INT_TO_STRING, 1, 0, 0);
  memory[i++].u = OP(OP_PRINT_STRING, 0, 1, 0); /* print(sum.toS()); */
  memory[i++].u = OP(OP_HALT, 0, 0, 0);
  /* fn add() */
  memory[i++].u = OP(OP_POPI, 0, 0, 0); /* a int */
  memory[i++].u = OP(OP_POPI, 1, 0, 0); /* b int */
  memory[i++].u = OP(OP_ADD_INT, 2, 1, 0); /* a + b */
  memory[i++].u = OP(OP_PUSHI, 2, 0, 0); /* push on stack */
  memory[i++].u = OP(OP_RETURN, 0, 0, 0);
  return i;
}

uint32_t test_recursive_function_compile(Value *memory) {
  uint32_t i = 0;
  /* fn main() */
  memory[i++].u = OP(OP_LOADI, 0, 0, 0); /* 35 */
  memory[i++].i = 35;
  memory[i++].u = OP(OP_PUSHI, 0, 0, 0);
  memory[i++].u = OP(OP_CALL, 0, 0, 0); /* ); */
  memory[i++].u = 9;
  memory[i++].u = OP(OP_POPI, 0, 0, 0); /* get return value */
  memory[i++].u = OP(OP_INT_TO_STRING, 1, 0, 0);
  memory[i++].u = OP(OP_PRINT_STRING, 0, 1, 0); /* print(fib(35).toS()); */
  memory[i++].u = OP(OP_HALT, 0, 0, 0);
  /* fn fib() */
  memory[i++].u = OP(OP_POPI, 0, 0, 0); /* n int */
  memory[i++].u = OP(OP_LOADI, 1, 0, 0); /* 2 */
  memory[i++].i = 2;
  memory[i++].u = OP(OP_LOADI, 2, 0, 0); /* &fib */
  memory[i++].i = 32;
  memory[i++].u = OP(OP_JLT_INT, 2, 0, 1); 
  memory[i++].u = OP(OP_LOADI, 3, 0, 0); /* 2 */
  memory[i++].i = 2;
  memory[i++].u = OP(OP_SUB_INT, 4, 0, 3);
  memory[i++].u = OP(OP_PUSHI, 4, 0, 0);
  memory[i++].u = OP(OP_CALL, 0, 0, 0); /* fib(n - 2) */
  memory[i++].u = 9;
  memory[i++].u = OP(OP_LOADI, 3, 0, 0); /* 1 */
  memory[i++].i = 1;
  memory[i++].u = OP(OP_SUB_INT, 4, 0, 3);
  memory[i++].u = OP(OP_PUSHI, 4, 0, 0);
  memory[i++].u = OP(OP_CALL, 0, 0, 0); /* fib(n - 1) */
  memory[i++].u = 9;
  memory[i++].u = OP(OP_POPI, 4, 0, 0); 
  memory[i++].u = OP(OP_POPI, 5, 0, 0); 
  memory[i++].u = OP(OP_ADD_INT, 6, 5, 4);
  memory[i++].u = OP(OP_PUSHI, 6, 0, 0);
  memory[i++].u = OP(OP_RETURN, 0, 0, 0);
  memory[i++].u = OP(OP_PUSHI, 0, 0, 0); 
  memory[i++].u = OP(OP_RETURN, 0, 0, 0);
  return i;
}
